using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Threading;
using System.Windows.Forms;



namespace DemoLib
{
    [ComVisible(true), GuidAttribute("AD7144BF-3730-46F5-A5B6-DDA760575C61")]
    public delegate bool RunTimeCallback(Int32 smartPosition, string text);

    [ComVisible(true), GuidAttribute("9C7B484A-EFE1-45B2-ADE6-042601741914")]
    public class pluginclass
    {
        string _newValue = "";

        public int RunTimeExecute(Int32 window, string variables, string state, Int32 callback, ref Int32 returnVal, ref string newval, bool firstiteration)
        {

            if (firstiteration)
            {
                // do something in the first iteration
                MessageBox.Show("We are inside of the net assembly, it is the first iteration\nvariables=\"" + variables + "\"\nstate=\"" + state + "\"");


                if (callback != 0)
                {
                    IntPtr ptr = new IntPtr(callback);
                    RunTimeCallback callbackMethod = (RunTimeCallback)Marshal.GetDelegateForFunctionPointer(ptr, typeof(RunTimeCallback));
                    callbackMethod(0, "Initialize");
                    Thread.Sleep(1000);
                    callbackMethod(50, "Half");
                    Thread.Sleep(1000);
                    callbackMethod(100, "Finalize");
                }
                _newValue = "New value from .Net";
                returnVal = 0;
                return _newValue.Length;
            }
            // second iteration
            MessageBox.Show("We are inside of the net assembly, it is the second iteration\nvariables=\"" + variables + "\"\nstate=\"" + state + "\"");
            newval = _newValue;
            return 0;
        }
    }
}
